/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */

import {
  Account,
  EncodedAccount,
  FetchAccountConfig,
  FetchAccountsConfig,
  assertAccountExists,
  decodeAccount,
  fetchEncodedAccount,
  fetchEncodedAccounts,
} from '@solana/accounts';
import {
  Address,
  getAddressDecoder,
  getAddressEncoder,
} from '@solana/addresses';
import {
  Codec,
  Decoder,
  Encoder,
  combineCodec,
  mapEncoder,
} from '@solana/codecs-core';
import {
  getStructDecoder,
  getStructEncoder,
} from '@solana/codecs-data-structures';
import { getU8Decoder, getU8Encoder } from '@solana/codecs-numbers';
import {
  Option,
  OptionOrNullable,
  getOptionDecoder,
  getOptionEncoder,
} from '@solana/options';
import { TmKey, TmKeyArgs, getTmKeyDecoder, getTmKeyEncoder } from '../types';

export type CollectionAuthorityRecord<TAddress extends string = string> =
  Account<CollectionAuthorityRecordAccountData, TAddress>;

export type CollectionAuthorityRecordAccountData = {
  key: TmKey;
  bump: number;
  updateAuthority: Option<Address>;
};

export type CollectionAuthorityRecordAccountDataArgs = {
  bump: number;
  updateAuthority: OptionOrNullable<Address>;
};

export function getCollectionAuthorityRecordAccountDataEncoder() {
  return mapEncoder(
    getStructEncoder<{
      key: TmKeyArgs;
      bump: number;
      updateAuthority: OptionOrNullable<Address>;
    }>([
      ['key', getTmKeyEncoder()],
      ['bump', getU8Encoder()],
      ['updateAuthority', getOptionEncoder(getAddressEncoder())],
    ]),
    (value) => ({ ...value, key: TmKey.CollectionAuthorityRecord })
  ) satisfies Encoder<CollectionAuthorityRecordAccountDataArgs>;
}

export function getCollectionAuthorityRecordAccountDataDecoder() {
  return getStructDecoder<CollectionAuthorityRecordAccountData>([
    ['key', getTmKeyDecoder()],
    ['bump', getU8Decoder()],
    ['updateAuthority', getOptionDecoder(getAddressDecoder())],
  ]) satisfies Decoder<CollectionAuthorityRecordAccountData>;
}

export function getCollectionAuthorityRecordAccountDataCodec(): Codec<
  CollectionAuthorityRecordAccountDataArgs,
  CollectionAuthorityRecordAccountData
> {
  return combineCodec(
    getCollectionAuthorityRecordAccountDataEncoder(),
    getCollectionAuthorityRecordAccountDataDecoder()
  );
}

export function decodeCollectionAuthorityRecord<
  TAddress extends string = string
>(
  encodedAccount: EncodedAccount<TAddress>
): CollectionAuthorityRecord<TAddress> {
  return decodeAccount(
    encodedAccount,
    getCollectionAuthorityRecordAccountDataDecoder()
  );
}

export async function fetchCollectionAuthorityRecord<
  TAddress extends string = string
>(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  address: Address<TAddress>,
  config?: FetchAccountConfig
): Promise<CollectionAuthorityRecord<TAddress>> {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  assertAccountExists(maybeAccount);
  return decodeCollectionAuthorityRecord(maybeAccount);
}

export async function safeFetchCollectionAuthorityRecord<
  TAddress extends string = string
>(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  address: Address<TAddress>,
  config?: FetchAccountConfig
): Promise<CollectionAuthorityRecord<TAddress> | null> {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return maybeAccount.exists
    ? decodeCollectionAuthorityRecord(maybeAccount)
    : null;
}

export async function fetchAllCollectionAuthorityRecord(
  rpc: Parameters<typeof fetchEncodedAccounts>[0],
  addresses: Array<Address>,
  config?: FetchAccountsConfig
): Promise<CollectionAuthorityRecord[]> {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map((maybeAccount) => {
    assertAccountExists(maybeAccount);
    return decodeCollectionAuthorityRecord(maybeAccount);
  });
}

export async function safeFetchAllCollectionAuthorityRecord(
  rpc: Parameters<typeof fetchEncodedAccounts>[0],
  addresses: Array<Address>,
  config?: FetchAccountsConfig
): Promise<CollectionAuthorityRecord[]> {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts
    .filter((maybeAccount) => maybeAccount.exists)
    .map((maybeAccount) =>
      decodeCollectionAuthorityRecord(maybeAccount as EncodedAccount)
    );
}
