/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */

import {
  Account,
  EncodedAccount,
  FetchAccountConfig,
  FetchAccountsConfig,
  assertAccountExists,
  decodeAccount,
  fetchEncodedAccount,
  fetchEncodedAccounts,
} from '@solana/accounts';
import {
  Address,
  ProgramDerivedAddress,
  getAddressEncoder,
  getProgramDerivedAddress,
} from '@solana/addresses';
import {
  Codec,
  Decoder,
  Encoder,
  combineCodec,
  mapEncoder,
} from '@solana/codecs-core';
import {
  getStructDecoder,
  getStructEncoder,
} from '@solana/codecs-data-structures';
import { getU8Decoder, getU8Encoder } from '@solana/codecs-numbers';
import { getStringEncoder } from '@solana/codecs-strings';
import {
  DelegateRole,
  DelegateRoleArgs,
  TmKey,
  TmKeyArgs,
  getDelegateRoleDecoder,
  getDelegateRoleEncoder,
  getTmKeyDecoder,
  getTmKeyEncoder,
} from '../types';

export type DelegateRecord<TAddress extends string = string> = Account<
  DelegateRecordAccountData,
  TAddress
>;

export type DelegateRecordAccountData = {
  key: TmKey;
  role: DelegateRole;
  bump: number;
};

export type DelegateRecordAccountDataArgs = {
  role: DelegateRoleArgs;
  bump: number;
};

export function getDelegateRecordAccountDataEncoder() {
  return mapEncoder(
    getStructEncoder<{ key: TmKeyArgs; role: DelegateRoleArgs; bump: number }>([
      ['key', getTmKeyEncoder()],
      ['role', getDelegateRoleEncoder()],
      ['bump', getU8Encoder()],
    ]),
    (value) => ({ ...value, key: TmKey.Delegate })
  ) satisfies Encoder<DelegateRecordAccountDataArgs>;
}

export function getDelegateRecordAccountDataDecoder() {
  return getStructDecoder<DelegateRecordAccountData>([
    ['key', getTmKeyDecoder()],
    ['role', getDelegateRoleDecoder()],
    ['bump', getU8Decoder()],
  ]) satisfies Decoder<DelegateRecordAccountData>;
}

export function getDelegateRecordAccountDataCodec(): Codec<
  DelegateRecordAccountDataArgs,
  DelegateRecordAccountData
> {
  return combineCodec(
    getDelegateRecordAccountDataEncoder(),
    getDelegateRecordAccountDataDecoder()
  );
}

export function decodeDelegateRecord<TAddress extends string = string>(
  encodedAccount: EncodedAccount<TAddress>
): DelegateRecord<TAddress> {
  return decodeAccount(encodedAccount, getDelegateRecordAccountDataDecoder());
}

export async function fetchDelegateRecord<TAddress extends string = string>(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  address: Address<TAddress>,
  config?: FetchAccountConfig
): Promise<DelegateRecord<TAddress>> {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  assertAccountExists(maybeAccount);
  return decodeDelegateRecord(maybeAccount);
}

export async function safeFetchDelegateRecord<TAddress extends string = string>(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  address: Address<TAddress>,
  config?: FetchAccountConfig
): Promise<DelegateRecord<TAddress> | null> {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return maybeAccount.exists ? decodeDelegateRecord(maybeAccount) : null;
}

export async function fetchAllDelegateRecord(
  rpc: Parameters<typeof fetchEncodedAccounts>[0],
  addresses: Array<Address>,
  config?: FetchAccountsConfig
): Promise<DelegateRecord[]> {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map((maybeAccount) => {
    assertAccountExists(maybeAccount);
    return decodeDelegateRecord(maybeAccount);
  });
}

export async function safeFetchAllDelegateRecord(
  rpc: Parameters<typeof fetchEncodedAccounts>[0],
  addresses: Array<Address>,
  config?: FetchAccountsConfig
): Promise<DelegateRecord[]> {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts
    .filter((maybeAccount) => maybeAccount.exists)
    .map((maybeAccount) =>
      decodeDelegateRecord(maybeAccount as EncodedAccount)
    );
}

export function getDelegateRecordSize(): number {
  return 282;
}

export type DelegateRecordSeeds = {
  /** The delegate role */
  role: DelegateRoleArgs;
};

export async function findDelegateRecordPda(
  seeds: DelegateRecordSeeds,
  config: { programAddress?: Address | undefined } = {}
): Promise<ProgramDerivedAddress> {
  const {
    programAddress = 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s' as Address<'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'>,
  } = config;
  return getProgramDerivedAddress({
    programAddress,
    seeds: [
      getStringEncoder({ size: 'variable' }).encode('delegate_record'),
      getAddressEncoder().encode(programAddress),
      getDelegateRoleEncoder().encode(seeds.role),
    ],
  });
}

export async function fetchDelegateRecordFromSeeds(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  seeds: DelegateRecordSeeds,
  config: FetchAccountConfig & { programAddress?: Address } = {}
): Promise<DelegateRecord> {
  const { programAddress, ...fetchConfig } = config;
  const [address] = await findDelegateRecordPda(seeds, { programAddress });
  return fetchDelegateRecord(rpc, address, fetchConfig);
}

export async function safeFetchDelegateRecordFromSeeds(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  seeds: DelegateRecordSeeds,
  config: FetchAccountConfig & { programAddress?: Address } = {}
): Promise<DelegateRecord | null> {
  const { programAddress, ...fetchConfig } = config;
  const [address] = await findDelegateRecordPda(seeds, { programAddress });
  return safeFetchDelegateRecord(rpc, address, fetchConfig);
}
