/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */

import {
  Account,
  EncodedAccount,
  FetchAccountConfig,
  FetchAccountsConfig,
  assertAccountExists,
  decodeAccount,
  fetchEncodedAccount,
  fetchEncodedAccounts,
} from '@solana/accounts';
import {
  Address,
  ProgramDerivedAddress,
  getAddressEncoder,
  getProgramDerivedAddress,
} from '@solana/addresses';
import {
  Codec,
  Decoder,
  Encoder,
  combineCodec,
  mapEncoder,
} from '@solana/codecs-core';
import {
  getStructDecoder,
  getStructEncoder,
} from '@solana/codecs-data-structures';
import { getU64Decoder, getU64Encoder } from '@solana/codecs-numbers';
import { getStringEncoder } from '@solana/codecs-strings';
import {
  Option,
  OptionOrNullable,
  getOptionDecoder,
  getOptionEncoder,
} from '@solana/options';
import { TmKey, TmKeyArgs, getTmKeyDecoder, getTmKeyEncoder } from '../types';

export type MasterEditionV2<TAddress extends string = string> = Account<
  MasterEditionV2AccountData,
  TAddress
>;

export type MasterEditionV2AccountData = {
  key: TmKey;
  supply: bigint;
  maxSupply: Option<bigint>;
};

export type MasterEditionV2AccountDataArgs = {
  supply: number | bigint;
  maxSupply: OptionOrNullable<number | bigint>;
};

export function getMasterEditionV2AccountDataEncoder() {
  return mapEncoder(
    getStructEncoder<{
      key: TmKeyArgs;
      supply: number | bigint;
      maxSupply: OptionOrNullable<number | bigint>;
    }>([
      ['key', getTmKeyEncoder()],
      ['supply', getU64Encoder()],
      ['maxSupply', getOptionEncoder(getU64Encoder())],
    ]),
    (value) => ({ ...value, key: TmKey.MasterEditionV2 })
  ) satisfies Encoder<MasterEditionV2AccountDataArgs>;
}

export function getMasterEditionV2AccountDataDecoder() {
  return getStructDecoder<MasterEditionV2AccountData>([
    ['key', getTmKeyDecoder()],
    ['supply', getU64Decoder()],
    ['maxSupply', getOptionDecoder(getU64Decoder())],
  ]) satisfies Decoder<MasterEditionV2AccountData>;
}

export function getMasterEditionV2AccountDataCodec(): Codec<
  MasterEditionV2AccountDataArgs,
  MasterEditionV2AccountData
> {
  return combineCodec(
    getMasterEditionV2AccountDataEncoder(),
    getMasterEditionV2AccountDataDecoder()
  );
}

export function decodeMasterEditionV2<TAddress extends string = string>(
  encodedAccount: EncodedAccount<TAddress>
): MasterEditionV2<TAddress> {
  return decodeAccount(encodedAccount, getMasterEditionV2AccountDataDecoder());
}

export async function fetchMasterEditionV2<TAddress extends string = string>(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  address: Address<TAddress>,
  config?: FetchAccountConfig
): Promise<MasterEditionV2<TAddress>> {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  assertAccountExists(maybeAccount);
  return decodeMasterEditionV2(maybeAccount);
}

export async function safeFetchMasterEditionV2<
  TAddress extends string = string
>(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  address: Address<TAddress>,
  config?: FetchAccountConfig
): Promise<MasterEditionV2<TAddress> | null> {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return maybeAccount.exists ? decodeMasterEditionV2(maybeAccount) : null;
}

export async function fetchAllMasterEditionV2(
  rpc: Parameters<typeof fetchEncodedAccounts>[0],
  addresses: Array<Address>,
  config?: FetchAccountsConfig
): Promise<MasterEditionV2[]> {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map((maybeAccount) => {
    assertAccountExists(maybeAccount);
    return decodeMasterEditionV2(maybeAccount);
  });
}

export async function safeFetchAllMasterEditionV2(
  rpc: Parameters<typeof fetchEncodedAccounts>[0],
  addresses: Array<Address>,
  config?: FetchAccountsConfig
): Promise<MasterEditionV2[]> {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts
    .filter((maybeAccount) => maybeAccount.exists)
    .map((maybeAccount) =>
      decodeMasterEditionV2(maybeAccount as EncodedAccount)
    );
}

export function getMasterEditionV2Size(): number {
  return 282;
}

export type MasterEditionV2Seeds = {
  /** The address of the mint account */
  mint: Address;
};

export async function findMasterEditionV2Pda(
  seeds: MasterEditionV2Seeds,
  config: { programAddress?: Address | undefined } = {}
): Promise<ProgramDerivedAddress> {
  const {
    programAddress = 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s' as Address<'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'>,
  } = config;
  return getProgramDerivedAddress({
    programAddress,
    seeds: [
      getStringEncoder({ size: 'variable' }).encode('metadata'),
      getAddressEncoder().encode(programAddress),
      getAddressEncoder().encode(seeds.mint),
      getStringEncoder({ size: 'variable' }).encode('edition'),
    ],
  });
}

export async function fetchMasterEditionV2FromSeeds(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  seeds: MasterEditionV2Seeds,
  config: FetchAccountConfig & { programAddress?: Address } = {}
): Promise<MasterEditionV2> {
  const { programAddress, ...fetchConfig } = config;
  const [address] = await findMasterEditionV2Pda(seeds, { programAddress });
  return fetchMasterEditionV2(rpc, address, fetchConfig);
}

export async function safeFetchMasterEditionV2FromSeeds(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  seeds: MasterEditionV2Seeds,
  config: FetchAccountConfig & { programAddress?: Address } = {}
): Promise<MasterEditionV2 | null> {
  const { programAddress, ...fetchConfig } = config;
  const [address] = await findMasterEditionV2Pda(seeds, { programAddress });
  return safeFetchMasterEditionV2(rpc, address, fetchConfig);
}
