/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */

import {
  Context,
  Pda,
  PublicKey,
  Signer,
  TransactionBuilder,
  transactionBuilder,
} from '@metaplex-foundation/umi';
import {
  Serializer,
  mapSerializer,
  struct,
  u8,
} from '@metaplex-foundation/umi/serializers';
import {
  PickPartial,
  ResolvedAccount,
  ResolvedAccountsWithIndices,
  expectPda,
  getAccountMetasAndSigners,
} from '../shared';
import {
  TaCreateArgs,
  TaCreateArgsArgs,
  getTaCreateArgsSerializer,
} from '../types';

// Accounts.
export type CreateRuleSetInstructionAccounts = {
  /** Payer and creator of the RuleSet */
  payer?: Signer;
  /** The PDA account where the RuleSet is stored */
  ruleSetPda: Pda;
  /** System program */
  systemProgram?: PublicKey | Pda;
};

// Data.
export type CreateRuleSetInstructionData = {
  discriminator: number;
  createArgs: TaCreateArgs;
  ruleSetBump: number;
};

export type CreateRuleSetInstructionDataArgs = {
  createArgs: TaCreateArgsArgs;
  ruleSetBump: number;
};

export function getCreateRuleSetInstructionDataSerializer(): Serializer<
  CreateRuleSetInstructionDataArgs,
  CreateRuleSetInstructionData
> {
  return mapSerializer<
    CreateRuleSetInstructionDataArgs,
    any,
    CreateRuleSetInstructionData
  >(
    struct<CreateRuleSetInstructionData>(
      [
        ['discriminator', u8()],
        ['createArgs', getTaCreateArgsSerializer()],
        ['ruleSetBump', u8()],
      ],
      { description: 'CreateRuleSetInstructionData' }
    ),
    (value) => ({ ...value, discriminator: 0 })
  ) as Serializer<
    CreateRuleSetInstructionDataArgs,
    CreateRuleSetInstructionData
  >;
}

// Args.
export type CreateRuleSetInstructionArgs = PickPartial<
  CreateRuleSetInstructionDataArgs,
  'ruleSetBump'
>;

// Instruction.
export function createRuleSet(
  context: Pick<Context, 'payer' | 'programs'>,
  input: CreateRuleSetInstructionAccounts & CreateRuleSetInstructionArgs
): TransactionBuilder {
  // Program ID.
  const programId = context.programs.getPublicKey(
    'mplTokenAuthRules',
    'auth9SigNpDKz4sJJ1DfCTuZrZNSAgh9sFD3rboVmgg'
  );

  // Accounts.
  const resolvedAccounts = {
    payer: {
      index: 0,
      isWritable: true as boolean,
      value: input.payer ?? null,
    },
    ruleSetPda: {
      index: 1,
      isWritable: true as boolean,
      value: input.ruleSetPda ?? null,
    },
    systemProgram: {
      index: 2,
      isWritable: false as boolean,
      value: input.systemProgram ?? null,
    },
  } satisfies ResolvedAccountsWithIndices;

  // Arguments.
  const resolvedArgs: CreateRuleSetInstructionArgs = { ...input };

  // Default values.
  if (!resolvedAccounts.payer.value) {
    resolvedAccounts.payer.value = context.payer;
  }
  if (!resolvedAccounts.systemProgram.value) {
    resolvedAccounts.systemProgram.value = context.programs.getPublicKey(
      'splSystem',
      '11111111111111111111111111111111'
    );
    resolvedAccounts.systemProgram.isWritable = false;
  }
  if (!resolvedArgs.ruleSetBump) {
    resolvedArgs.ruleSetBump = expectPda(resolvedAccounts.ruleSetPda.value)[1];
  }

  // Accounts in order.
  const orderedAccounts: ResolvedAccount[] = Object.values(
    resolvedAccounts
  ).sort((a, b) => a.index - b.index);

  // Keys and Signers.
  const [keys, signers] = getAccountMetasAndSigners(
    orderedAccounts,
    'programId',
    programId
  );

  // Data.
  const data = getCreateRuleSetInstructionDataSerializer().serialize(
    resolvedArgs as CreateRuleSetInstructionDataArgs
  );

  // Bytes Created On Chain.
  const bytesCreatedOnChain = 0;

  return transactionBuilder([
    { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
  ]);
}
